//
// Created by nicol on 2018-03-18.
//

#ifndef ESC_TCP_PACKAGE_H
#define ESC_TCP_PACKAGE_H

#include "utils/buffer.h"
#include "utils/uuid.h"

struct st_tcp_package {
    uint8_t command;
    uint8_t flags;
    esc_uuid_t correlation_id;
    const char* login;
    const char* password;
    buffer_t data;
};
typedef struct st_tcp_package* tcp_package_t;

tcp_package_t tcp_package_create(uint8_t command, esc_uuid_t correlation_id, buffer_t data);
tcp_package_t tcp_package_create_authenticated(uint8_t command, esc_uuid_t correlation_id, buffer_t data, const char* username, const char* password);
void tcp_package_destroy(tcp_package_t pkg);
buffer_t tcp_package_to_buffer(tcp_package_t pkg);
tcp_package_t tcp_package_from_buffer(buffer_t buffer);

#endif //ESC_TCP_PACKAGE_H
